Attribute VB_Name = "Module1"
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' 3217 Phoenixville Pike
' Malvern, PA  19355
' 800 321-5355 or 610 725-8800
' http://www.lawsonlabs.com
' Dec 2007
' VB demo. program for M40x A/D board,
' Uses DLL: M40x.DLL to access M401
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit
'DO NOT MODIFY THE ABOVE CONSTANTS
Public Selected_Index As Integer            'index which user wants to view/manipulate
Public Scan_obj(NumOf401s) As SSCAN_OBJ          'scan object, one for each index
Public Scan_volt(NumOf401s) As SSCAN_VOLTS_BUFF  'scan volts object, one for each index
Public IC_Array(NumOf401s) As INDEX_CONTEXT       'one for each index,
' saved context information of each index like IP_addr, log of activity etc
' used when user switched from one index to another
Public Const default_port = 23                  'default port
Public fExtScan As FrmExtScan
Public fMain As frmMain           'ViewOneM401 form
Public fScanData As frmScanData                 'Extra Form in multi channel scan
Public fViewALLM401s As frmViewALLM401s         'form to VIEW voltages of all connected
Public fError As frmError                       'form to view error
'M401s at a time
Public fGraph As frmGraph               ' form to plot grap
Public DLLCallRet As RETURN_CODE        'M401 DLL call return
Public CfgFileName As String            'config file name
Public ChangeFromOneM401Form As Boolean  'Set to true if switching indexs from fMain form
Public flgUsingCallBack As Boolean       'If true then using callback approach, false using
Private ExtraSetting(0 To MAX_EXTRA_SETTING) As String
Private ExtraSettingLen As Integer
Public bNetworkEventThreadPriority As Byte
Public bNetworkPollThreadPriority As Byte
Public flgUsingNetworkEventThread As Boolean
Public ulNumOfExScanChans As Long
Public nSecCounter As Integer
' non callback
Dim hCfgFile ' handle to the cfg file


'06/06/2003
' DPC_Selected_Channel stores the channel being used for screen display
' house keeping, though this information is available in bSelChanOrNumOfChan
' in single channel mode, application needs to keep track of this in multi
' channel mode.

Public Type INDEX_CONTEXT
    DPC_EvtLogWnd As String         ' Store the event list box
    DPC_Connect As Boolean          ' Is this device port connected to a M401
    DPC_IPAddr  As String           ' IP address of M401 connected to this index
    DPC_Subnet  As String           ' Subnet mask of M401 connected to this device
    DPC_Gateway As String           ' Gateway for this M401
    DPC_DhcpTimeout As String       ' Dhcp timeout for this M401
    DPC_CheckSumError As Boolean    ' when M401 is scanning, did a CheckSumError error occur
    DPC_ScanOverFlow As Boolean     ' when M401 is scanning, did a ScanOverFlow error occur
    DPC_ADChipCorrupted As Boolean  ' when M401 is scanning, did a ADChipCorrupted error occur
    DPC_Selected_Channel As Integer ' New, stores selected channel (multi chan mode)
    DPC_ScanAvg As Byte             ' avg setting
    DPC_DispChan As Byte            ' Which channel to display in graph
    DPC_NumOfChan As Byte           ' Number of chans
    DPC_ScanRate  As Double         ' Scan rate user enetered on form for this index
    DPC_AcDcMode As Byte            '
    DPC_ScanMode As Byte            ' Last scan mode
    DPC_DigOut As Byte              ' Last Digital output entered on form, not what was sent
    DPC_ZoomIndex As Byte           ' Zoom setting in graph
    DPC_GraphTimeBase As Integer    ' save current time base settings for this index
    SE As Boolean                   ' is save enabled for this index
    FH As Integer                   ' Filehandle, when Save enabled and file type is not MDB
'   NewDB As Database               ' data base log file, if save enabled and file type = MDB
'   NewTable As TableDef            ' if save enabled and file type = MDB
'   rs As Recordset                 ' if save enabled and file type = MDB
    FileType As String              ' if save enabled, file type string
    ExtScan_AD0_Start As Long       ' new variables to store extended scan setup
    ExtScan_AD0_End As Long         ' information
    ExtScan_AD1_Start As Long       '
    ExtScan_AD1_End As Long         '
    ExtScan_AD6 As Byte             ' 0 AD6 not selected
    ExtScan_AD7 As Byte             ' 1 AD7 selected
    bExtCalScan As Byte             ' 2- cal scan with subchan 0 as offset, 1 - extended cal scan, 0 - regular extended scan
    fExScans(0 To 399) As Double    ' extended scans
    bExDigInp(0 To 399) As Byte     ' digital inputs in extended scan
    ulNumOfExScans As Long          ' number of scans in fExScans, bExDigInp
    bMuxInverted As Byte
    ulScanCounts As Long            ' total number of scans received so far
    flgErrorLog As Boolean
    bTrigInput As Byte              ' the digital input connected to the trigger source
    bTrigEdge As Byte               ' trigger edge:up or down
    bTrigOn As Byte                 ' bTrigOn = 1, triggered scan, else regular scan
    ' variables uses in extended calibration scan with subchan 0  as offset
    fAD0_SubChan_Min(0 To 15) As Double
    fAD0_SubChan_Max(0 To 15) As Double
    fAD1_SubChan_Min(0 To 15) As Double
    fAD1_SubChan_Max(0 To 15) As Double
    'If  AD1 sub chan 0 is selected then offset of AD1 sub chan 0 from the start of
    ' the scan. Note AD sub chan 0 if selected is always at offset 0 as it is the
    ' first channel in the scan
    Ad1SubChan0Offset As Long
    bNumOfExChans As Byte 'the total number of chans (including sub chans) in 1 extended scan
    ' Configuration settings for thermocouples connected to thermometer on AD0 and AD1
    fAD0_K(0 To 15) As Double
    fAD0_G(0 To 15) As Double
    fAD0_Type(0 To 15) As String
    fAD1_K(0 To 15) As Double
    fAD1_G(0 To 15) As Double
    fAD1_Type(0 To 15) As String
    bFaren As Byte '0 for temp in centigrade, 1 for temp in farenheight
    ' variable to stores plot multiple channel settings
    ' store channel color settings
    PlotAD0ChanClr(0 To 15) As Long
    PlotAD1ChanClr(0 To 15) As Long
    PlotAD6ChanClr As Long
    PlotAD7ChanClr As Long
    ' Plot all scanned channels that are set to true
    PlotAD0ChanShow(0 To 15) As Boolean
    PlotAD1ChanShow(0 To 15) As Boolean
    PlotAD6ChanShow As Boolean
    PlotAD7ChanShow As Boolean
    bTrigWaiting As Byte '1 if the index is waiting for a trigger, 0 otherwise
End Type

'A variable of type INDEX_CONTEXT  for each index, when user switches
'indexs, setting of current index are saved in its INDEX_CONTEXT
'and setting restored for next index from its INDEX_CONTEXT





'declaration for functions and subroutines
'this declaration MUST have same type of argument defined in M40x.dll


'System DLL
Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Integer) As Long


'CALLED IN SCAN MODE BY DLL WHEN SCAN DATA BECOMES AVAILABLE
Sub WhenRecABlock()
'This call back function is defined for DLL
'In SCAN mode when dll receive a block of data, after processing,
'this sub is called to update display, logging data and etc.
'Application may do some simple processing on data before data is displayed.
'To make sure data will not overlap or cause data writting latency
'this sub shouldn't use any time consuming functions or sub calls which cause time delay
'At this time, when we scan at highest rate(1000Hz) and use data base
'file to log, it may generates latency because of disk data access delay

' Note:
' If application uses more than one index and all have same callback function,
' like this demo, check bDataReady field to find out which index called callback
' don't forget to set bDataReady to 0
' Make sure that callback or any function called from call does not create a modal dialog/window
  Dim ulScanCnt As Long
  Dim fResult As Double
    Dim bPlotChan As Byte
    Dim MsgRetCode As Long
    Dim FormIndex As Integer
    For FormIndex = 0 To NumOf401s - 1
        'If this M401 has data ready
      If Scan_obj(FormIndex).bDataReady <> 0 Then
         Scan_obj(FormIndex).bDataReady = 0
         If IC_Array(FormIndex).SE Then   'if data logging is enabled
                    Call WriteScanTxtFile(FormIndex)   'write to text file
          End If
            'Only 1st data in voltage scan buffer is displayed
            'Is this index selected
             If Selected_Index = FormIndex Then
                'if this index is selected by user then update form
                ' Check for errors and report them
                If Scan_obj(FormIndex).bScanBuffOverLapped Or Scan_obj(FormIndex).bChkSumErr Or Scan_obj(FormIndex).bADChipRegCorrupted Then
                    Call fMain.EnableShowError
                End If
                ulScanCnt = Scan_obj(FormIndex).ulScanCounts
                If fGraph.Visible Then      'when we need to plot scan data
                    fGraph.Plot            'plot one pixle at a time
                End If
                'next is to display all channel voltage readings
                'Only 1st data in voltage scan buffer is displayed
                fResult = Scan_volt(FormIndex).fVolts(0, fMain.bSelChan)
                fMain.EditVoltage.Text = FormatVolts(fResult, FormIndex)
                Call UpdateMainForm(FormIndex, fMain.bSelChan, fMain.EditVoltage.Text)
                fMain.EditDigin.Text = Scan_obj(FormIndex).bDigIn(0)
                fResult = Scan_volt(FormIndex).fEffectiveBits(fMain.bSelChan)
                fMain.EffBitEdit.Text = Format$(fResult, "##0.0")
                fResult = Scan_volt(FormIndex).fVoltsMin(fMain.bSelChan)
                fMain.MinReading.Text = FormatVolts(fResult, FormIndex)
                fResult = Scan_volt(FormIndex).fVoltsMax(fMain.bSelChan)
                fMain.MaxReading.Text = FormatVolts(fResult, FormIndex)
                fMain.txtScansCompleted.Text = ulScanCnt
                If Scan_obj(FormIndex).bScanMode = MULT_CHAN_SCAN Or Scan_obj(FormIndex).bScanMode = MULT_CHAN_CAL_SCAN Then
                  fScanData.txtActualScanRate = Format$(Scan_obj(FormIndex).fMultiChanScanRate, "##0.00")
                  If Scan_obj(FormIndex).bScanMode = MULT_CHAN_CAL_SCAN Then
                    fResult = Scan_volt(FormIndex).fVolts(0, 7)
                    fScanData.txtScanVolts7.Text = FormatVolts(fResult, FormIndex)
                    Call UpdateMainForm(FormIndex, 7, fScanData.txtScanVolts7.Text)
                  End If
                  fResult = Scan_volt(FormIndex).fVolts(0, 0)
                  fScanData.txtScanVolts0.Text = FormatVolts(fResult, FormIndex)
                  Call UpdateMainForm(FormIndex, 0, fScanData.txtScanVolts0.Text)
                  If (Scan_obj(FormIndex).bScanMode = MULT_CHAN_CAL_SCAN And (Scan_obj(FormIndex).bSelChanOrNumOfChan - 1) = 1) Or (Scan_obj(FormIndex).bSelChanOrNumOfChan = 1) Then
                     Exit Sub
                  End If
                  fResult = Scan_volt(FormIndex).fVolts(0, 1)
                  fScanData.txtScanVolts1.Text = FormatVolts(fResult, FormIndex)
                  Call UpdateMainForm(FormIndex, 1, fScanData.txtScanVolts1.Text)
                  If (Scan_obj(FormIndex).bScanMode = MULT_CHAN_CAL_SCAN And (Scan_obj(FormIndex).bSelChanOrNumOfChan - 1) = 2) Or (Scan_obj(FormIndex).bSelChanOrNumOfChan = 2) Then
                     Exit Sub
                  End If
                  fResult = Scan_volt(FormIndex).fVolts(0, 6)
                  fScanData.txtScanVolts6.Text = FormatVolts(fResult, FormIndex)
                  Call UpdateMainForm(FormIndex, 6, fScanData.txtScanVolts6.Text)
                  If (Scan_obj(FormIndex).bScanMode = MULT_CHAN_CAL_SCAN And (Scan_obj(FormIndex).bSelChanOrNumOfChan - 1) = 3) Or (Scan_obj(FormIndex).bSelChanOrNumOfChan = 3) Then
                     Exit Sub
                  End If
                  fResult = Scan_volt(FormIndex).fVolts(0, 7)
                  fScanData.txtScanVolts7.Text = FormatVolts(fResult, FormIndex)
                  Call UpdateMainForm(FormIndex, 7, fScanData.txtScanVolts7.Text)
                End If
             Else
            ' Data ready but index not selected for viewing, so store error values in
            ' index_context structure and continue to update ViewAllM401s
                If Scan_obj(FormIndex).bScanBuffOverLapped Then IC_Array(FormIndex).DPC_ScanOverFlow = True
                If Scan_obj(FormIndex).bChkSumErr Then IC_Array(FormIndex).DPC_CheckSumError = True
                If Scan_obj(FormIndex).bADChipRegCorrupted Then IC_Array(FormIndex).DPC_ADChipCorrupted = True
                fResult = Scan_volt(FormIndex).fVolts(0, Scan_obj(FormIndex).bSelChanOrNumOfChan)
                Call UpdateMainForm(FormIndex, Scan_obj(FormIndex).bSelChanOrNumOfChan, FormatVolts(fResult, FormIndex))
                If Scan_obj(FormIndex).bScanMode = MULT_CHAN_SCAN Or Scan_obj(FormIndex).bScanMode = MULT_CHAN_CAL_SCAN Then
                    If Scan_obj(FormIndex).bScanMode = MULT_CHAN_CAL_SCAN Then
                        fResult = Scan_volt(FormIndex).fVolts(0, 7)
                        Call UpdateMainForm(FormIndex, 7, FormatVolts(fResult, FormIndex))
                    End If
                    fResult = Scan_volt(FormIndex).fVolts(0, 0)
                    Call UpdateMainForm(FormIndex, 0, FormatVolts(fResult, FormIndex))
                
                    fResult = Scan_volt(FormIndex).fVolts(0, 1)
                    Call UpdateMainForm(FormIndex, 1, FormatVolts(fResult, FormIndex))
                
                    fResult = Scan_volt(FormIndex).fVolts(0, 6)
                    Call UpdateMainForm(FormIndex, 6, FormatVolts(fResult, FormIndex))
                
                    fResult = Scan_volt(FormIndex).fVolts(0, 7)
                    Call UpdateMainForm(FormIndex, 7, FormatVolts(fResult, FormIndex))
                End If
            End If
        End If
    Next
End Sub

Sub Main()
    Dim Index, bRet, i As Integer
    Dim DllReadMethod As Integer
    ExtraSettingLen = 0
    If M40xDLL.M40xDLL_Init() = False Then
        Call MsgBox(M40xDLL.M40xDLL_szError)
        End
    End If
    flgUsingNetworkEventThread = False
    CfgFileName = M40xDLL.M40xDLL_szPath & "M40x.cfg" 'This file contains the settings for all the 8 indices
    
    If Not CheckFilePresent(M40xDLL.M40xDLL_szPath & "Callback.cfg") Then
        ' No Callback.cfg then Method 3 - event-driven thread in the dll collects data from the network and
        ' the application polls the dll for new data
        flgUsingNetworkEventThread = True
        flgUsingCallBack = False
    Else
        'Callback.cfg present, then check for keywords
        If CheckForKeyWord(M40xDLL.M40xDLL_szPath & "Callback.cfg", "EVENT_THREAD") Then
           flgUsingNetworkEventThread = True
        End If
        flgUsingCallBack = True
        If CheckForKeyWord(M40xDLL.M40xDLL_szPath & "Callback.cfg", "NO_CALLBACK") Then
           flgUsingCallBack = False
        End If
        
        If (Not flgUsingNetworkEventThread) And (flgUsingCallBack) Then
            DllReadMethod = 1
        ElseIf flgUsingNetworkEventThread And flgUsingCallBack Then
            DllReadMethod = 2
        ElseIf flgUsingNetworkEventThread And (Not flgUsingCallBack) Then
            DllReadMethod = 3
        Else
            DllReadMethod = 4
        End If
    End If
    
    For Index = 0 To NumOf401s - 1
        'Init all the indices with default settings, if cfg file not found then the default settings are used
        Init_Index (Index)
        'register each index for the selected method of reading data from the dll
        If DllReadMethod = 1 Then
            If M40xDLL.M40xDLL_Register_Method_1(Scan_obj(Index), Scan_volt(Index), AddressOf WhenRecABlock) = False Then
                Call MsgBox(M40xDLL.M40xDLL_szError)
                End
            End If
        ElseIf DllReadMethod = 2 Then
            If M40xDLL.M40xDLL_Register_Method_2(Scan_obj(Index), Scan_volt(Index), AddressOf WhenRecABlock) = False Then
                Call MsgBox(M40xDLL.M40xDLL_szError)
                End
            End If
        ElseIf DllReadMethod = 3 Then
            If M40xDLL.M40xDLL_Register_Method_3(Scan_obj(Index), Scan_volt(Index)) = False Then
                Call MsgBox(M40xDLL.M40xDLL_szError)
                End
            End If
        Else
            ' Method 4
            If M40xDLL.M40xDLL_Register_Method_4(Scan_obj(Index), Scan_volt(Index)) = False Then
                Call MsgBox(M40xDLL.M40xDLL_szError)
                End
            End If
        End If
    Next
   ' Load index settings if saved in cfg file
   Set fScanData = New frmScanData           'create a form for mulitchannel scan data
   Set fMain = New frmMain                   'create the  main form
   Set fViewALLM401s = New frmViewALLM401s   'create a form to show scan voltages of all the scanning indices
   Set fGraph = New frmGraph                    'create a form to display graph
   Set fError = New frmError
   Set fExtScan = New FrmExtScan
   Call fExtScan.SaveOrgX
   fGraph.BkgGrphColor = RGB(255, 0, 0)
   Call LoadSetting
   fMain.Show
   
  For i = 0 To NumOf401s - 1
    fMain.CmbIPAddrEdit.AddItem (i & "= " & (IC_Array(i).DPC_IPAddr))   ' Fill the IP address combo box with IP addresses of M401 last connected to each index.
  Next
  'Fill CmbIPAddrEdit with index and ip (default/saved)
  fMain.CmbIPAddrEdit.ListIndex = 0
  fMain.IP = IC_Array(0).DPC_IPAddr
  Selected_Index = 0
  Call Restore_INDEX_CONTEXT
  ' set focus to first index
  ChangeFromOneM401Form = False
  If flgUsingCallBack Then
     fMain.Timer1.Enabled = False
     'fMain.Indicator.Caption = "Using Callback"
  End If
'Show user which method is being used
If Not flgUsingNetworkEventThread Then
  If Not flgUsingCallBack Then
   fMain.ScanAcquisitionMethod.Caption = "Timer"
   fMain.SetMenuThreadPriority (bNetworkPollThreadPriority)
  Else
    fMain.ScanAcquisitionMethod.Caption = "Callback"
    fMain.TopThreadPriority.Enabled = False
  End If
Else
    If Not flgUsingCallBack Then
        fMain.ScanAcquisitionMethod.Caption = "EventThread-Timer"
    Else
        fMain.ScanAcquisitionMethod.Caption = "EvenThread-Callback"
    End If
    fMain.SetMenuThreadPriority (bNetworkEventThreadPriority)
End If
nSecCounter = 0
End Sub


Sub WriteScanTxtFile(Index As Integer)
    'when scan log file is text format file, write scan log data
    'into text file
    Dim i, j, k, l, lResult As Long
    If Scan_obj(Index).bScanMode = SINGLE_CHAN_SCAN Then
        For i = 0 To Scan_obj(Index).RevDataPoints - 1
           Print #IC_Array(Index).FH, Format$(Scan_obj(Index).ulScanCounts - Scan_obj(Index).RevDataPoints + i, "000000000"); "  ";
           Print #IC_Array(Index).FH, FormatVolts(Scan_volt(Index).fVolts(i, Scan_obj(Index).bLastScanChan), Index); "   ";
           Print #IC_Array(Index).FH, Scan_obj(Index).bDigIn(i)
        Next i
       Exit Sub
    ElseIf Scan_obj(Index).bScanMode = MULT_CHAN_SCAN Or Scan_obj(Index).bScanMode = MULT_CHAN_CAL_SCAN Then
        If Scan_obj(Index).bSelChanOrNumOfChan <> 0 Then
            k = Scan_obj(Index).RevDataPoints / Scan_obj(Index).bSelChanOrNumOfChan
        Else
            k = Scan_obj(Index).RevDataPoints
        End If
        For i = 0 To k - 1
            Print #IC_Array(Index).FH, Format$(Scan_obj(Index).ulScanCounts - k + i, "000000000"); "  ";
            For j = 0 To Scan_obj(Index).bSelChanOrNumOfChan - 1
                If j > 1 Then
                   l = j + 4
                Else
                   l = j
                End If
                If (Scan_obj(Index).bScanMode = MULT_CHAN_CAL_SCAN) And (j = (Scan_obj(Index).bSelChanOrNumOfChan - 1)) Then l = 7
                Print #IC_Array(Index).FH, FormatVolts(Scan_volt(Index).fVolts(i, l), Index); "   ";
                
            Next j
            'BUG Print #IC_Array(Index).FH, Scan_obj(Index).bDigIn(i)
            Print #IC_Array(Index).FH, Scan_obj(Index).bDigIn((i * Scan_obj(Index).bSelChanOrNumOfChan) + (Scan_obj(Index).bSelChanOrNumOfChan - 1)) 'BUGFIX
            'Note - every data point is associated with a digital input but to save space only the digital input associated with
            'the the last data point of the scan is logged
        Next i
        Exit Sub
    Else
        'Extended scan and Extended cal scan
        k = 0
        For i = 0 To IC_Array(Index).ulNumOfExScans - 1
            Print #IC_Array(Index).FH, Format$((IC_Array(Index).ulScanCounts - IC_Array(Index).ulNumOfExScans + i + 1), "000000000"); "  ";
            If IC_Array(Index).ExtScan_AD0_Start >= 0 Then
                'Log AD0 sub channel volts
                For j = IC_Array(Index).ExtScan_AD0_Start To IC_Array(Index).ExtScan_AD0_End
                    Print #IC_Array(Index).FH, FormatVolts(IC_Array(Index).fExScans(k), Index); "   ";
                    k = k + 1
                Next
            End If
            If IC_Array(Index).ExtScan_AD1_Start >= 0 Then
                'Log AD1 sub channels
                For j = IC_Array(Index).ExtScan_AD1_Start To IC_Array(Index).ExtScan_AD1_End
                    Print #IC_Array(Index).FH, FormatVolts(IC_Array(Index).fExScans(k), Index); "   ";
                    k = k + 1
                Next
            End If
            If IC_Array(Index).ExtScan_AD6 <> 0 Then
                Print #IC_Array(Index).FH, FormatVolts(IC_Array(Index).fExScans(k), Index); "   ";
                k = k + 1
            End If
            If IC_Array(Index).ExtScan_AD7 <> 0 Then
                Print #IC_Array(Index).FH, FormatVolts(IC_Array(Index).fExScans(k), Index); "   ";
                k = k + 1
            End If
            'print data point associate with the last channel of the scan
            Print #IC_Array(Index).FH, IC_Array(Index).bExDigInp(k - 1)
        Next
    End If
End Sub
' 08/03/2007
Sub Calibrate_ExScans_With_SubChan0_Offset(Index As Integer)
Dim i, j, k, lCurScanOffset, Ad1SubChan0Offset As Long
lCurScanOffset = 0
Ad1SubChan0Offset = IC_Array(Index).Ad1SubChan0Offset
For j = 0 To (IC_Array(Index).ulNumOfExScans - 1)
   If IC_Array(Index).ExtScan_AD0_Start = 0 Then
        'AD chan 0 cal with subchan 0 as offset
        For i = 1 To IC_Array(Index).ExtScan_AD0_End
            IC_Array(Index).fExScans(lCurScanOffset + i) = IC_Array(Index).fExScans(lCurScanOffset + i) - IC_Array(Index).fExScans(lCurScanOffset + 0)
                'update min, max
                 If (IC_Array(Index).fAD0_SubChan_Min(i) > IC_Array(Index).fExScans(lCurScanOffset + i)) Then IC_Array(Index).fAD0_SubChan_Min(i) = IC_Array(Index).fExScans(lCurScanOffset + i)
                 If (IC_Array(Index).fAD0_SubChan_Max(i) < IC_Array(Index).fExScans(lCurScanOffset + i)) Then IC_Array(Index).fAD0_SubChan_Max(i) = IC_Array(Index).fExScans(lCurScanOffset + i)
        Next i
   End If
                         
   If IC_Array(Index).ExtScan_AD1_Start = 0 Then
        'AD chan 1 cal with subchan 0 as offset
        For i = 1 To IC_Array(Index).ExtScan_AD1_End
            IC_Array(Index).fExScans(lCurScanOffset + Ad1SubChan0Offset + i) = IC_Array(Index).fExScans(lCurScanOffset + Ad1SubChan0Offset + i) - IC_Array(Index).fExScans(lCurScanOffset + Ad1SubChan0Offset)
            'update min, max
            If IC_Array(Index).fAD1_SubChan_Min(i) > IC_Array(Index).fExScans(lCurScanOffset + Ad1SubChan0Offset + i) Then IC_Array(Index).fAD1_SubChan_Min(i) = IC_Array(Index).fExScans(lCurScanOffset + Ad1SubChan0Offset + i)
            If IC_Array(Index).fAD1_SubChan_Max(i) < IC_Array(Index).fExScans(lCurScanOffset + Ad1SubChan0Offset + i) Then IC_Array(Index).fAD1_SubChan_Max(i) = IC_Array(Index).fExScans(lCurScanOffset + Ad1SubChan0Offset + i)
        Next i
   End If
   lCurScanOffset = lCurScanOffset + IC_Array(Selected_Index).bNumOfExChans
Next j
End Sub


Sub ReadNewExScanData(Index As Integer)
Dim ulNumScansToReturn, ulScansInBuff, ulNumScansReturned As Long
Dim bErrorFlags As Byte
ulNumScansToReturn = 0
If Scan_obj(Index).bScanStopped <> 0 Then Exit Sub
If Pub_ReadExScanDataDbl(Scan_obj(Index), IC_Array(Index).fExScans(0), IC_Array(Index).bExDigInp(0), ulNumScansToReturn, ulNumScansReturned, ulScansInBuff) <> 0 Then
    If ulScansInBuff = 0 Then
        Exit Sub    'no scans to read then exit
    ElseIf ulScansInBuff > 10 Then
        ulNumScansToReturn = 10
    Else
        ulNumScansToReturn = ulScansInBuff
    End If
    If Pub_ReadExScanDataDbl(Scan_obj(Index), IC_Array(Index).fExScans(0), IC_Array(Index).bExDigInp(0), ulNumScansToReturn, IC_Array(Index).ulNumOfExScans, ulScansInBuff) <> 0 Then
        If Scan_obj(Index).bScanBuffOverLapped Or Scan_obj(Index).bChkSumErr Or Scan_obj(Index).bADChipRegCorrupted Then
            Call fMain.EnableShowError
        End If
        If IC_Array(Index).bExtCalScan = 2 Or IC_Array(Index).bExtCalScan = 3 Then
            '08/01/2007 - V1.16.4 code to support calibration scan with subchan 0 as offset
            '(necessary for thermometer temperature calculations)
            Call Calibrate_ExScans_With_SubChan0_Offset(Index)
        End If
        If IC_Array(Index).bExtCalScan = 3 Then Call Thermo.CalcAllTemps(Index)
        
        IC_Array(Index).ulScanCounts = IC_Array(Index).ulScanCounts + IC_Array(Index).ulNumOfExScans
        If Index = Selected_Index Then
            ' if this is selected index then update forms
            Call fExtScan.ShowExtendedScans
        End If
        If IC_Array(Index).SE Then
          Call WriteScanTxtFile(Index)
        End If
        If Index = Selected_Index Then Call fGraph.Plot
    End If
End If
End Sub



' Called by timer every 10ms. Calls Pub_ReadScanData for every index with second parameter set to 0.
' On return the second parameter contains the number of new scan data points available to the application.
' Read all the available data to minimize latency.
Sub ReadNewScanData()
Dim ulScanCnt As Long
Dim fResult As Double
Dim bPlotChan As Byte
Dim MsgRetCode As Long
Dim FormIndex As Integer
Dim ulNumPointsToRead As Long
Dim Ad1SubChan0Offset As Long
For FormIndex = 0 To NumOf401s - 1
  ulNumPointsToRead = 0
  If IC_Array(FormIndex).DPC_Connect And (Scan_obj(FormIndex).bScanStopped = 0) Then
      If Scan_obj(FormIndex).bScanMode = EXTENDED_SCAN Or Scan_obj(FormIndex).bScanMode = EXTENDED_CAL_SCAN Then
          Call ReadNewExScanData(FormIndex)
          If (IC_Array(FormIndex).bTrigOn = 1) And (IC_Array(FormIndex).bTrigWaiting = 1) And (IC_Array(FormIndex).ulScanCounts > 0) Then
                IC_Array(FormIndex).bTrigWaiting = 0
                If FormIndex = Selected_Index Then
                    fMain.PictTrigMsg.Visible = False
                    Call fMain.AddLogWnd("TRIGGERED")
                Else
                    IC_Array(FormIndex).DPC_EvtLogWnd = IC_Array(FormIndex).DPC_EvtLogWnd & Time$ & " TRIGGERED  " & Chr(10)
                End If
          End If
      Else
          If Pub_ReadScanData(Scan_obj(FormIndex), ulNumPointsToRead) <> 0 Then
          ' Succeeded in getting the number of data points in the internal buffer
          ' of the DLL.
              Do While ulNumPointsToRead <> 0
              'There are scan data points in the internal buffer so read them
                  If Pub_ReadScanData(Scan_obj(FormIndex), ulNumPointsToRead) <> 0 Then
                      'SSCAN_OBJ and SSCAN_VOLTS_BUFF structure of this index updated
                      ' process the new scan data points here
                      'If this index has data
                       If IC_Array(FormIndex).SE Then   'if data logging is enabled
                              Call WriteScanTxtFile(FormIndex)   'write to text file
                        End If
                      'Only 1st data in voltage scan buffer is displayed
                      'If this index is selected
                      If Selected_Index = FormIndex Then
                            'if this index is selected by user then update form  Check for errors and report them
                             If Scan_obj(FormIndex).bScanBuffOverLapped Or Scan_obj(FormIndex).bChkSumErr Or Scan_obj(FormIndex).bADChipRegCorrupted Then
                                 Call fMain.EnableShowError
                             End If
                             ulScanCnt = Scan_obj(FormIndex).ulScanCounts
                             If fGraph.Visible Then      'when we need to plot scan data
                                 fGraph.Plot            'plot one pixle at a time
                             End If
                             'next is to display all channel voltage readings
                             'Only 1st data in voltage scan buffer is displayed
                             fResult = Scan_volt(FormIndex).fVolts(0, fMain.bSelChan)
                             fMain.EditVoltage.Text = FormatVolts(fResult, FormIndex)
                             Call UpdateMainForm(FormIndex, fMain.bSelChan, fMain.EditVoltage.Text)
                             fMain.EditDigin.Text = Scan_obj(FormIndex).bDigIn(0)
                             fResult = Scan_volt(FormIndex).fEffectiveBits(fMain.bSelChan)
                             fMain.EffBitEdit.Text = Format$(fResult, "##0.0")
                             fResult = Scan_volt(FormIndex).fVoltsMin(fMain.bSelChan)
                             fMain.MinReading.Text = FormatVolts(fResult, FormIndex)
                             fResult = Scan_volt(FormIndex).fVoltsMax(fMain.bSelChan)
                             fMain.MaxReading.Text = FormatVolts(fResult, FormIndex)
                             fMain.txtScansCompleted.Text = ulScanCnt
                             If Scan_obj(FormIndex).bScanMode = MULT_CHAN_SCAN Or Scan_obj(FormIndex).bScanMode = MULT_CHAN_CAL_SCAN Then
                                fScanData.txtActualScanRate = Format$(Scan_obj(FormIndex).fMultiChanScanRate, "##0.00")
                                If Scan_obj(FormIndex).bScanMode = MULT_CHAN_CAL_SCAN Then
                                  fResult = Scan_volt(FormIndex).fVolts(0, 7)
                                  fScanData.txtScanVolts7.Text = FormatVolts(fResult, FormIndex)
                                  Call UpdateMainForm(FormIndex, 7, fScanData.txtScanVolts7.Text)
                                End If
                                fResult = Scan_volt(FormIndex).fVolts(0, 0)
                                fScanData.txtScanVolts0.Text = FormatVolts(fResult, FormIndex)
                                Call UpdateMainForm(FormIndex, 0, fScanData.txtScanVolts0.Text)
                                If (Scan_obj(FormIndex).bScanMode = MULT_CHAN_CAL_SCAN And (Scan_obj(FormIndex).bSelChanOrNumOfChan - 1) = 1) Or (Scan_obj(FormIndex).bSelChanOrNumOfChan = 1) Then
                                   Exit Sub
                                End If
                                fResult = Scan_volt(FormIndex).fVolts(0, 1)
                                fScanData.txtScanVolts1.Text = FormatVolts(fResult, FormIndex)
                                Call UpdateMainForm(FormIndex, 1, fScanData.txtScanVolts1.Text)
                                If (Scan_obj(FormIndex).bScanMode = MULT_CHAN_CAL_SCAN And (Scan_obj(FormIndex).bSelChanOrNumOfChan - 1) = 2) Or (Scan_obj(FormIndex).bSelChanOrNumOfChan = 2) Then
                                   Exit Sub
                                End If
                                fResult = Scan_volt(FormIndex).fVolts(0, 6)
                                fScanData.txtScanVolts6.Text = FormatVolts(fResult, FormIndex)
                                Call UpdateMainForm(FormIndex, 6, fScanData.txtScanVolts6.Text)
                                If (Scan_obj(FormIndex).bScanMode = MULT_CHAN_CAL_SCAN And (Scan_obj(FormIndex).bSelChanOrNumOfChan - 1) = 3) Or (Scan_obj(FormIndex).bSelChanOrNumOfChan = 3) Then
                                   Exit Sub
                                End If
                                fResult = Scan_volt(FormIndex).fVolts(0, 7)
                                fScanData.txtScanVolts7.Text = FormatVolts(fResult, FormIndex)
                                Call UpdateMainForm(FormIndex, 7, fScanData.txtScanVolts7.Text)
                             End If
                      Else
                        ' Data ready but index not selected for viewing, so store error values in
                        ' index_context structure and continue to update ViewAllM401s
                            If Scan_obj(FormIndex).bScanBuffOverLapped Then IC_Array(FormIndex).DPC_ScanOverFlow = True
                            If Scan_obj(FormIndex).bChkSumErr Then IC_Array(FormIndex).DPC_CheckSumError = True
                            If Scan_obj(FormIndex).bADChipRegCorrupted Then IC_Array(FormIndex).DPC_ADChipCorrupted = True
                            
                            fResult = Scan_volt(FormIndex).fVolts(0, Scan_obj(FormIndex).bSelChanOrNumOfChan)
                            Call UpdateMainForm(FormIndex, Scan_obj(FormIndex).bSelChanOrNumOfChan, FormatVolts(fResult, FormIndex))
                            If Scan_obj(FormIndex).bScanMode = MULT_CHAN_SCAN Or Scan_obj(FormIndex).bScanMode = MULT_CHAN_CAL_SCAN Then
                                If Scan_obj(FormIndex).bScanMode = MULT_CHAN_CAL_SCAN Then
                                    fResult = Scan_volt(FormIndex).fVolts(0, 7)
                                    Call UpdateMainForm(FormIndex, 7, FormatVolts(fResult, FormIndex))
                                End If
                                fResult = Scan_volt(FormIndex).fVolts(0, 0)
                                Call UpdateMainForm(FormIndex, 0, FormatVolts(fResult, FormIndex))
                            
                                fResult = Scan_volt(FormIndex).fVolts(0, 1)
                                Call UpdateMainForm(FormIndex, 1, FormatVolts(fResult, FormIndex))
                            
                                fResult = Scan_volt(FormIndex).fVolts(0, 6)
                                Call UpdateMainForm(FormIndex, 6, FormatVolts(fResult, FormIndex))
                            
                                fResult = Scan_volt(FormIndex).fVolts(0, 7)
                                Call UpdateMainForm(FormIndex, 7, FormatVolts(fResult, FormIndex))
                            End If
                      End If
                  Else
                      'In multichannel scan if the application request a partial scan Pub_ReadScanData
                      ' returns false. Application must try again
                      'Call MsgBox("Pub_ReadScanData Failed")
                      Exit Do
                  End If
                 ulNumPointsToRead = ulNumPointsToRead - Scan_obj(FormIndex).RevDataPoints
             Loop
             ' In triggered start scan, hide the message after the trigger,
             If (IC_Array(FormIndex).bTrigOn = 1) And (IC_Array(FormIndex).bTrigWaiting = 1) And (Scan_obj(FormIndex).ulScanCounts > 0) Then
                IC_Array(FormIndex).bTrigWaiting = 0
                If FormIndex = Selected_Index Then
                    fMain.PictTrigMsg.Visible = False
                    Call fMain.AddLogWnd("TRIGGERED")
                Else
                    IC_Array(FormIndex).DPC_EvtLogWnd = IC_Array(FormIndex).DPC_EvtLogWnd & Time$ & " TRIGGERED  " & Chr(10)
                End If
             End If
           End If
      End If
  End If
Next
End Sub

Sub UpdateMainForm(Index As Integer, Chan As Byte, Voltage As String)
If Chan = 0 Then fViewALLM401s.M401_Chan0(Index).Text = Voltage
If Chan = 1 Then fViewALLM401s.M401_Chan1(Index).Text = Voltage
If Chan = 6 Then fViewALLM401s.M401_Chan6(Index).Text = Voltage
If Chan = 7 Then fViewALLM401s.M401_Chan7(Index).Text = Voltage
End Sub

Sub ClearVoltDsp(Index As Integer)
    'Clear all volts display boxes
    fScanData.txtScanVolts0.Text = "         "
    fScanData.txtScanVolts1.Text = "         "
    fScanData.txtScanVolts2.Text = "         "
    fScanData.txtScanVolts3.Text = "         "
    fScanData.txtScanVolts4.Text = "         "
    fScanData.txtScanVolts5.Text = "         "
    fScanData.txtScanVolts6.Text = "         "
    fScanData.txtScanVolts7.Text = "         "
End Sub

Sub Save_INDEX_CONTEXT()
Dim i As Integer
IC_Array(Selected_Index).DPC_IPAddr = fMain.IP
If fMain.Connect.Caption = "&Disconnect" Then
    IC_Array(Selected_Index).DPC_Connect = True
Else
    IC_Array(Selected_Index).DPC_Connect = False
End If
IC_Array(Selected_Index).DPC_EvtLogWnd = ""
For i = 0 To fMain.EvtLogWnd.ListCount - 1
     IC_Array(Selected_Index).DPC_EvtLogWnd = IC_Array(Selected_Index).DPC_EvtLogWnd & fMain.EvtLogWnd.List(i) & Chr(10)
Next
' save error status
If Scan_obj(Selected_Index).bScanBuffOverLapped Then
    IC_Array(Selected_Index).DPC_ScanOverFlow = True
Else
    IC_Array(Selected_Index).DPC_ScanOverFlow = False
End If

If Scan_obj(Selected_Index).bChkSumErr Then
    IC_Array(Selected_Index).DPC_CheckSumError = True
Else
    IC_Array(Selected_Index).DPC_CheckSumError = False
End If

If Scan_obj(Selected_Index).bADChipRegCorrupted Then
    IC_Array(Selected_Index).DPC_ADChipCorrupted = True
Else
    IC_Array(Selected_Index).DPC_ADChipCorrupted = False
End If

If fMain.OptMultiChan.Value = True Then
'MULTI CHAN OR EXTENDED SCAN
    If fMain.ChkExtScan = 1 Then
        'EXTENDED SCAN
        IC_Array(Selected_Index).DPC_ScanMode = EXTENDED_SCAN
    Else
        'MULTI CHAN SCAN
        If fMain.CheckCalScan = 1 Then
            'MULTI CHAN CAL SCAN
            IC_Array(Selected_Index).DPC_ScanMode = MULT_CHAN_CAL_SCAN
        Else
            IC_Array(Selected_Index).DPC_ScanMode = MULT_CHAN_SCAN
        End If
    End If
Else
'SINGLE CHAN SCAN
    IC_Array(Selected_Index).DPC_ScanMode = SINGLE_CHAN_SCAN
End If

IC_Array(Selected_Index).DPC_Selected_Channel = fMain.bSelChan
IC_Array(Selected_Index).DPC_DispChan = fMain.dispChan
IC_Array(Selected_Index).DPC_ZoomIndex = fMain.bZoomIndex
IC_Array(Selected_Index).DPC_ScanAvg = fMain.ComboAvg.Text
IC_Array(Selected_Index).DPC_NumOfChan = fMain.ComboScanArg.Text
IC_Array(Selected_Index).DPC_ScanRate = fMain.ComboRate.Text
If fMain.chkErrorLog.Value = vbChecked Then
    IC_Array(Selected_Index).flgErrorLog = True
Else
    IC_Array(Selected_Index).flgErrorLog = False
End If
If fMain.ChkTrigScan.Value = vbChecked Then
    IC_Array(Selected_Index).bTrigOn = 1
Else
    IC_Array(Selected_Index).bTrigOn = 0
End If
End Sub
Sub Restore_INDEX_CONTEXT()
Dim bTemp As Byte
Dim i, nPos, nLastPos As Integer
fMain.FlgInternalChng = True
fMain.bZoomIndex = IC_Array(Selected_Index).DPC_ZoomIndex
fMain.CmbIPAddrEdit.List(Selected_Index) = Selected_Index & "= " & IC_Array(Selected_Index).DPC_IPAddr
fMain.CmbIPAddrEdit.ListIndex = Selected_Index
fMain.IP = IC_Array(Selected_Index).DPC_IPAddr
fMain.BtnSendChan.BackColor = &H8000000F
fMain.SndRateBtn.BackColor = &H8000000F
fScanData.Hide
fExtScan.Hide
fMain.Refresh
fMain.PictTrigMsg.Visible = False
fMain.ComboRate.Text = IC_Array(Selected_Index).DPC_ScanRate
'CONNECTED. ENABLE ALL.
fMain.ResetMaxMinBtn.Enabled = True
fScanData.Hide
fMain.ComboRate.Enabled = True
fMain.ComboAvg.Enabled = True
fMain.txtScansCompleted.Text = ""
fMain.Connect.Caption = "&Disconnect"
fMain.BtnGetConv.Enabled = True
fMain.BtnSysCal.Enabled = True
fMain.SndRateBtn.Enabled = True
fMain.BtnSignOn.Enabled = True
fMain.SelfTest.Enabled = True
fMain.UpdateRTC.Enabled = True
fMain.cfgM401.Enabled = True
fMain.OptSingleChan.Enabled = True
fMain.OptMultiChan.Enabled = True
fMain.CheckCalScan.Enabled = True
'fMain.ComboScanArg.Enabled = True
fMain.BtnSendChan.Enabled = True
fMain.BtnSendChan.Enabled = True
fMain.BtnSendDigout.Enabled = True
fMain.ChkExtScan.Enabled = True
fMain.CheckDoLogFile.Enabled = True
fMain.CmdShowErrors.Enabled = True
fMain.chkErrorLog.Enabled = True
fMain.chkErrorLog.Value = 0
fMain.CmdTestPins.Enabled = True
fMain.ChkTrigScan.Enabled = True
fMain.cmdTrigScanSetup.Enabled = True
fMain.BtnScan.Enabled = True
fMain.Caption = fMain.CmbIPAddrEdit.List(Selected_Index)
fMain.Refresh
'RESTORE LOG
fMain.EvtLogWnd.Clear
nLastPos = 1
nPos = InStr(nLastPos, IC_Array(Selected_Index).DPC_EvtLogWnd, Chr(10), vbTextCompare)
Do While nPos
    fMain.EvtLogWnd.AddItem (Mid$(IC_Array(Selected_Index).DPC_EvtLogWnd, nLastPos, nPos - nLastPos))
    nLastPos = nPos + 1
    nPos = InStr(nLastPos, IC_Array(Selected_Index).DPC_EvtLogWnd, Chr(10), vbTextCompare)
Loop
If fMain.EvtLogWnd.ListCount > 0 Then fMain.EvtLogWnd.ListIndex = fMain.EvtLogWnd.ListCount - 1  'highlight the last message list item
'AVG, NUM OF CHANS, DATA RATE SETTINGS
fMain.ComboAvg.Text = CInt(IC_Array(Selected_Index).DPC_ScanAvg)
fMain.ComboScanArg.Text = IC_Array(Selected_Index).DPC_NumOfChan
fMain.ComboRate.Text = IC_Array(Selected_Index).DPC_ScanRate
fMain.OptMultiChan = 0
fScanData.Hide
'LOG TO DATA FILE ENABLED
If IC_Array(Selected_Index).SE Then
   fMain.CheckDoLogFile.Value = 1
Else
   fMain.CheckDoLogFile.Value = 0
End If
'ERROR LOG ENABLED
If IC_Array(Selected_Index).flgErrorLog Then
    fMain.chkErrorLog.Value = vbChecked
Else
    fMain.chkErrorLog.Value = 0
End If
'TRIGGER START SCAN
If IC_Array(Selected_Index).bTrigOn = 1 Then
    fMain.ChkTrigScan.Value = vbChecked
Else
    fMain.ChkTrigScan.Value = 0
End If
'SELECTED CHANNEL
fMain.bSelChan = IC_Array(Selected_Index).DPC_Selected_Channel
fMain.EditVoltage.Text = "" 'Clear main form volt box
'DETERMINE THE SCAN TYPE
If IC_Array(Selected_Index).DPC_ScanMode = MULT_CHAN_SCAN Or IC_Array(Selected_Index).DPC_ScanMode = MULT_CHAN_CAL_SCAN Then
    ' MULTI CHANNEL SCAN/MULTI CHANNEL CAL SCAN
    Call fMain.Show_Multi_Chan
    fMain.ChanSel.ListIndex = fMain.bSelChan
    fMain.ChkExtScan = 0
    If Scan_obj(Selected_Index).bScanStopped = 0 Then
        'If scanning write actual rate
        fScanData.Caption = fMain.CmbIPAddrEdit.List(Selected_Index)
        fScanData.Show
        fMain.TxtScanRate.Text = Scan_obj(Selected_Index).fScanRate / (5 * Scan_obj(Selected_Index).bSelChanOrNumOfChan)
    Else
        fMain.TxtScanRate.Text = ""
    End If
    fMain.OptMultiChan.Value = 1
    'clear scan data volt boxes
    fScanData.txtScanVolts0 = ""
    fScanData.txtScanVolts1 = ""
    fScanData.txtScanVolts2 = ""
    fScanData.txtScanVolts3 = ""
    fScanData.txtScanVolts4 = ""
    fScanData.txtScanVolts5 = ""
    fScanData.txtScanVolts6 = ""
    fScanData.txtScanVolts7 = ""
    If IC_Array(Selected_Index).DPC_ScanMode = MULT_CHAN_CAL_SCAN Then
        fMain.CheckCalScan.Value = 1
    Else
        fMain.CheckCalScan.Value = 0
    End If
    bTemp = IC_Array(Selected_Index).DPC_Selected_Channel
    If (bTemp >= 0) And (bTemp < 8) Then
        fMain.EffBitEdit.Text = Format$(Scan_volt(Selected_Index).fEffectiveBits(bTemp), "##0.0")
        fMain.MinReading.Text = Format$(Scan_volt(Selected_Index).fVoltsMin(bTemp), " #0.000000;-#0.000000")
        fMain.MaxReading.Text = Format$(Scan_volt(Selected_Index).fVoltsMax(bTemp), " #0.000000;-#0.000000")
        fMain.EditDigin.Text = Scan_obj(Selected_Index).bDigIn(0)
    End If
ElseIf IC_Array(Selected_Index).DPC_ScanMode = EXTENDED_SCAN Then
   ' IN EXTENDED SCAN / EXTENDED CAL SCAN
   fMain.ChanSel.ListIndex = fMain.bSelChan / 16
   Call fMain.Show_Multi_Chan
   fMain.ChkExtScan = 1
   fMain.CheckCalScan = 0
   If IC_Array(Selected_Index).bExtCalScan = 1 Then fMain.CheckCalScan = 1
   If Scan_obj(Selected_Index).bScanStopped = 0 Then
       fMain.TxtScanRate.Text = Scan_obj(Selected_Index).fMultiChanScanRate
       fExtScan.Show
   End If
   fMain.EditDigin.Text = IC_Array(Selected_Index).bExDigInp(0)
Else
   ' IN SINGLE CHANNEL SCAN MODE
   Call fMain.Show_Single_Chan
   fMain.ChanSel.ListIndex = fMain.bSelChan
   fMain.CheckCalScan = 0
   fMain.ChkExtScan = 0
   fMain.OptMultiChan.Value = 0
   fMain.CheckCalScan.Value = 0
   fMain.CheckCalScan.Enabled = False
   If Scan_obj(Selected_Index).bScanStopped = 0 Then
       fMain.TxtScanRate.Text = Scan_obj(Selected_Index).fScanRate
   Else
       fMain.TxtScanRate.Text = ""
   End If
   fMain.EffBitEdit.Text = Format$(Scan_volt(Selected_Index).fEffectiveBits(Scan_obj(Selected_Index).bLastScanChan), "##0.0")
   fMain.MinReading.Text = Format$(Scan_volt(Selected_Index).fVoltsMin(Scan_obj(Selected_Index).bLastScanChan), " #0.000000;-#0.000000")
   fMain.MaxReading.Text = Format$(Scan_volt(Selected_Index).fVoltsMax(Scan_obj(Selected_Index).bLastScanChan), " #0.000000;-#0.000000")
   fMain.EditDigin.Text = Scan_obj(Selected_Index).bDigIn(0)
End If
fMain.txtScansCompleted.Text = Scan_obj(Selected_Index).ulScanCounts
fMain.BtnSendChan.Enabled = True
'COMMON SCANNING/POLLED SETTINGS
If Scan_obj(Selected_Index).bScanStopped Then
     'SCAN STOPPED
     fMain.ShowGraphic.Enabled = False
     fMain.CmdDiff.Enabled = True
     fMain.BtnSendChan.Enabled = True
     fMain.ComboRate.Enabled = True
     fMain.BtnScan.Caption = "Start Scan"
     fMain.BtnGetConv.Enabled = True
     fMain.BtnSysCal.Enabled = True
     fMain.SndRateBtn.Enabled = True
     fMain.BtnSignOn.Enabled = True
     fMain.SelfTest.Enabled = True
     fMain.UpdateRTC.Enabled = True
     fMain.cfgM401.Enabled = True
     fMain.ComboRate.Enabled = True
     fMain.ComboAvg.Enabled = True
     fMain.ShowGraphic.Enabled = False
     fMain.CheckDoLogFile.Enabled = True
     fMain.BtnSendDigout.Enabled = True
     fMain.CmdShowErrors.Enabled = True
     fMain.chkErrorLog.Enabled = True
     fMain.CmdTestPins.Enabled = True
     fMain.OptSingleChan.Enabled = True
     fMain.OptMultiChan.Enabled = True
Else
     'SCANNING IN PROGRESS
     fGraph.init
     fMain.ShowGraphic.Enabled = True
     fMain.CmdDiff.Enabled = False
     fMain.CmdExtScanSetup.Enabled = False
     fMain.ComboRate.Enabled = False
     fMain.BtnGetConv.Enabled = False
     fMain.BtnScan.Caption = "Stop Scan"
     fMain.BtnSysCal.Enabled = False
     fMain.SndRateBtn.Enabled = False
     fMain.BtnSignOn.Enabled = False
     fMain.SelfTest.Enabled = False
     fMain.UpdateRTC.Enabled = False
     fMain.cfgM401.Enabled = False
     fMain.OptSingleChan.Enabled = False
     fMain.OptMultiChan.Enabled = False
     fMain.CheckCalScan.Enabled = False
     fMain.ComboScanArg.Enabled = False
     fMain.ComboRate.Enabled = False
     fMain.ComboAvg.Enabled = False
     fMain.BtnSendDigout.Enabled = True
     fMain.ChanSel.Enabled = True
     fMain.CmdShowErrors.Enabled = False
     fMain.chkErrorLog.Enabled = False
     fMain.CmdTestPins.Enabled = False
     fMain.cmdTrigScanSetup.Enabled = False
     fMain.CheckDoLogFile.Enabled = False
     fMain.ChkExtScan.Enabled = False
     fMain.OptMultiChan.Enabled = False
     fMain.CheckCalScan.Enabled = False
     fMain.ChkTrigScan.Enabled = False
     '08/01/2007
     If (IC_Array(Selected_Index).bTrigOn = 1) Then
        If (Scan_obj(Selected_Index).bScanMode = EXTENDED_SCAN) Or (Scan_obj(Selected_Index).bScanMode = EXTENDED_CAL_SCAN) Then
            'Extended scan
            If (IC_Array(Selected_Index).ulScanCounts = 0) Then fMain.PictTrigMsg.Visible = True
        Else
            'singled channel/multi-channel/multi=channel cal scan
            If (Scan_obj(Selected_Index).ulScanCounts = 0) Then fMain.PictTrigMsg.Visible = True
        End If
     End If
            
End If
If IC_Array(Selected_Index).DPC_ScanOverFlow Or IC_Array(Selected_Index).DPC_CheckSumError Or IC_Array(Selected_Index).DPC_ADChipCorrupted Then
    Call fMain.EnableShowError
Else
    Call fMain.ResetShowError
End If
fMain.BtnSendChan.BackColor = &H8000000F
fMain.SndRateBtn.BackColor = &H8000000F
fMain.CmdShowErrors.BackColor = &H8000000F

If Not IC_Array(Selected_Index).DPC_Connect Then    'NOT CONNECTED THEN EXIT
    fMain.OptSingleChan.Enabled = False
    fMain.ComboRate.Enabled = False
    fMain.ComboAvg.Enabled = False
    fMain.txtScansCompleted.Text = ""
    fMain.Connect.Caption = "&Connect"
    fMain.BtnGetConv.Enabled = False
    fMain.BtnSysCal.Enabled = False
    fMain.SndRateBtn.Enabled = False
    fMain.BtnSignOn.Enabled = False
    fMain.SelfTest.Enabled = False
    fMain.UpdateRTC.Enabled = False
    fMain.cfgM401.Enabled = False
    fMain.OptMultiChan.Enabled = False
    fMain.CheckCalScan.Enabled = False
    fMain.ComboScanArg.Enabled = False
    fMain.BtnSendChan.Enabled = False
    fMain.BtnSendChan.Enabled = False
    fMain.BtnSendDigout.Enabled = False
    fMain.ChkExtScan.Enabled = False
    fMain.CheckDoLogFile.Enabled = False
    fMain.CmdShowErrors.Enabled = False
    fMain.chkErrorLog.Enabled = False
    fMain.chkErrorLog.Value = 0
    fMain.CmdTestPins.Enabled = False
    fMain.ChkTrigScan.Enabled = False
    fMain.cmdTrigScanSetup.Enabled = False
    fMain.BtnScan.Enabled = False
    fMain.CmdExtScanSetup.Enabled = False
    fMain.CmdDiff.Enabled = False
    fMain.ResetMaxMinBtn.Enabled = False
End If
fMain.Refresh
fMain.FlgInternalChng = False
End Sub




' Initialize index context variable for each index with default values, if a
' cfg file not found then these values are used instead.
Sub Init_Index(Index As Integer)
    Dim bRet As Byte
    Dim i As Integer
    IC_Array(Index).bTrigWaiting = 0
    IC_Array(Index).DPC_Connect = False
    IC_Array(Index).DPC_EvtLogWnd = ""
    IC_Array(Index).SE = False
    IC_Array(Index).DPC_AcDcMode = 0
    IC_Array(Index).DPC_ADChipCorrupted = False
    IC_Array(Index).DPC_CheckSumError = False
    IC_Array(Index).DPC_DhcpTimeout = 0
    IC_Array(Index).DPC_DigOut = 0
    IC_Array(Index).DPC_DispChan = 0
    IC_Array(Index).DPC_Gateway = ""
    IC_Array(Index).DPC_IPAddr = ""
    IC_Array(Index).DPC_NumOfChan = 2
    IC_Array(Index).DPC_ScanAvg = 4
    IC_Array(Index).DPC_ScanMode = POLLED_MODE
    IC_Array(Index).DPC_ScanOverFlow = False
    IC_Array(Index).DPC_ScanRate = 100
    IC_Array(Index).DPC_Subnet = "255.255.255.0"
    IC_Array(Index).DPC_ZoomIndex = 0
    IC_Array(Index).DPC_GraphTimeBase = 1
    IC_Array(Index).DPC_Selected_Channel = 0
    IC_Array(Index).ExtScan_AD0_Start = -1
    IC_Array(Index).ExtScan_AD1_Start = -1
    IC_Array(Index).ExtScan_AD6 = 0
    IC_Array(Index).ExtScan_AD7 = 0
    IC_Array(Index).bExtCalScan = 0
    IC_Array(Index).bMuxInverted = 0
    IC_Array(Index).flgErrorLog = False
    IC_Array(Index).bTrigInput = 0
    IC_Array(Index).bTrigEdge = 0
    IC_Array(Index).bTrigOn = 0
    IC_Array(Index).bFaren = 0
    For i = 0 To 15
        ' Default settings for tcs connected to AD0
        IC_Array(Index).fAD0_G(i) = 1
        IC_Array(Index).fAD0_K(i) = 1
        IC_Array(Index).fAD0_Type(i) = "J"
        ' default settings for tcs connected to AD1
        IC_Array(Index).fAD1_G(i) = 1
        IC_Array(Index).fAD1_K(i) = 1
        IC_Array(Index).fAD1_Type(i) = "J"
    Next
    
    For i = 0 To 15
        ' Default values for plot multiple channels settings
        IC_Array(Index).PlotAD0ChanClr(i) = RGB(0, 0, 255)
        IC_Array(Index).PlotAD1ChanClr(i) = RGB(0, 0, 255)
        IC_Array(Index).PlotAD0ChanShow(i) = False
        IC_Array(Index).PlotAD1ChanShow(i) = False
    Next
    IC_Array(Index).PlotAD6ChanClr = RGB(0, 0, 255)
    IC_Array(Index).PlotAD7ChanClr = RGB(0, 0, 255)
    IC_Array(Index).PlotAD6ChanShow = False
    IC_Array(Index).PlotAD7ChanShow = False
    
End Sub

'IP formatting/validating routines

Function stripIP(ByVal addr As String) As String

'  This routine removes blanks and leading zeros from an IP address in "dotted-quad" format,
'  and ensures that there are four fields, adding .0 fields if necessary.

Dim i As Integer, j As Integer
Dim s As String

   addr = Trim$(addr)                        '  trim external blank characters
   
   Do                                        '  strip internal blank characters
      j = InStr(addr, " ")                   '  find first/next blank characters
      If j = 0 Then Exit Do                  '  if absent, we are done
      addr = Left$(addr, j - 1) & Mid$(addr, j + 1)
   Loop
   
   addr = addr & "...."                      '  add extra dots incase user did not
   For i = 1 To 4                            '  now there should (at least) be four dots
      j = InStr(addr, ".")                   '  find first/next dot
      If j = 0 Then Exit For                 '  if absent, exit early (should never happen)
      s = s & CStr(CIntX(Left$(addr, j - 1)))   '  else strip leading zeros
      s = s & "."                            '  add the dot
      addr = Mid$(addr, j + 1)               '  remove from string
   Next i                                    '  and keep going

   stripIP = Left$(s, Len(s) - 1)            '  return stripped string, less final dot
   
End Function

Function CIntX(s As String) As Integer

   CIntX = 0
   On Error Resume Next
   CIntX = CInt(s)
   
End Function

'Before you close application make sure that all scans are stopped and all M401s are
'disconnected. Failure to stop scan can cause your application to crash on exit. Failure
'to disconnect from a M401 may cause delay when trying to connect to this M401 again.
Sub Exit_Application()
Dim i As Integer
fMain.AddLogWnd ("WAIT.....CLOSING ALL CONNECTIONS")
For i = 0 To NumOf401s - 1
    Do
        DLLCallRet = Pub_EndScan(Scan_obj(i))
   Loop While DLLCallRet = PENDING
   Call Pub_CloseConnection(Scan_obj(i))
Next
Call Save_INDEX_CONTEXT
' save current index context so that latest info can be stored in config file
Call SaveSetting
Call M40xDLL.M40xDLL_Shutdown
End
End Sub



Sub LoadSetting()
    Dim contentstr, i
    Dim CurrentIndexPos, j As Integer
    Dim Str As String
    Dim search As String
    On Error GoTo loadsettingerr    'if there is no such file
    CurrentIndexPos = 1
    Open CfgFileName For Input As #1
    'when CfgFileName exist, read its contents, do keyword search and
    'load presetings for all parameters, all indexs.
    For i = 0 To NumOf401s - 1
        CurrentIndexPos = GetNextIndexPos(CurrentIndexPos, IC_Array(i).DPC_IPAddr)
        If CurrentIndexPos = -1 Then Exit Sub  ' Next Index not found quit
        Call GetSettingValue(CurrentIndexPos, "Subnet mask:", IC_Array(i).DPC_Subnet)
        Call GetSettingValue(CurrentIndexPos, "GateWay IP :", IC_Array(i).DPC_Gateway)
        Call GetSettingValue(CurrentIndexPos, "DHCP tmout :", IC_Array(i).DPC_DhcpTimeout)
        
        If GetSettingValue(CurrentIndexPos, "Scan Avg   :", Str) Then
            IC_Array(i).DPC_ScanAvg = Val(Str)
            If IC_Array(i).DPC_ScanAvg = 0 Then IC_Array(i).DPC_ScanAvg = 1
            If (IC_Array(i).DPC_ScanAvg > 32) Then IC_Array(i).DPC_ScanAvg = 32
        End If
        If GetSettingValue(CurrentIndexPos, "Digital out:", Str) Then
            'fMainForm.EditDigout = Val(Mid$(contentstr, Len("Digital out:") + 1))
             IC_Array(i).DPC_DigOut = Val(Str)
        End If
        
        IC_Array(i).DPC_ScanMode = SINGLE_CHAN_SCAN
        Scan_obj(i).bScanMode = SINGLE_CHAN_SCAN
        
        
        If GetSettingValue(CurrentIndexPos, "Multi  chan:", Str) Then
            If Val(Str) = 1 Then
                IC_Array(i).DPC_ScanMode = MULT_CHAN_SCAN
                Scan_obj(i).bScanMode = MULT_CHAN_SCAN
            End If
        End If
        
        If GetSettingValue(CurrentIndexPos, "Ext Scan:", Str) Then
            If Val(Str) = 1 Then
                IC_Array(i).DPC_ScanMode = EXTENDED_SCAN
                Scan_obj(i).bScanMode = EXTENDED_SCAN
            End If
        End If
        
        If GetSettingValue(CurrentIndexPos, "Cal.   scan:", Str) Then
            If Val(Str) <> 0 Then
                If IC_Array(i).DPC_ScanMode = EXTENDED_SCAN Then
                    Scan_obj(i).bScanMode = EXTENDED_SCAN
                    IC_Array(i).bExtCalScan = Val(Str)
                Else
                    IC_Array(i).DPC_ScanMode = MULT_CHAN_CAL_SCAN
                    Scan_obj(i).bScanMode = MULT_CHAN_CAL_SCAN
                End If
            End If
        End If
        
        If GetSettingValue(CurrentIndexPos, "Number chan:", Str) Then
            IC_Array(i).DPC_NumOfChan = Val(Str)
            If IC_Array(i).DPC_NumOfChan = 0 Then IC_Array(i).DPC_NumOfChan = 1
            If (IC_Array(i).DPC_NumOfChan > 8) Then IC_Array(i).DPC_NumOfChan = 8
        End If
        
        If GetSettingValue(CurrentIndexPos, "AC/DC  mode:", Str) Then
            IC_Array(i).DPC_AcDcMode = Str
        End If
        
        If GetSettingValue(CurrentIndexPos, "Disp   chan:", Str) Then
            IC_Array(i).DPC_DispChan = Str
        End If
        
        If GetSettingValue(CurrentIndexPos, "Volts/Div  :", Str) Then
            IC_Array(i).DPC_ZoomIndex = Str
        End If
        
        If GetSettingValue(CurrentIndexPos, "Scan Rate  :", Str) Then
            IC_Array(i).DPC_ScanRate = Val(Str)
        End If
        
        If GetSettingValue(CurrentIndexPos, "GraphTimeBase  :", Str) Then
            IC_Array(i).DPC_GraphTimeBase = Val(Str)
        End If
        
       'Load Extended Scan settings
        If GetSettingValue(CurrentIndexPos, "EX_AD0_START:", Str) Then
            IC_Array(i).ExtScan_AD0_Start = Val(Str)
        End If
        
        If GetSettingValue(CurrentIndexPos, "EX_AD0_END:", Str) Then
            IC_Array(i).ExtScan_AD0_End = Val(Str)
        End If
        If GetSettingValue(CurrentIndexPos, "EX_AD1_START:", Str) Then
            IC_Array(i).ExtScan_AD1_Start = Val(Str)
        End If
        If GetSettingValue(CurrentIndexPos, "EX_AD1_END:", Str) Then
            IC_Array(i).ExtScan_AD1_End = Val(Str)
        End If
        
        If GetSettingValue(CurrentIndexPos, "EX_AD6:", Str) Then
            IC_Array(i).ExtScan_AD6 = Val(Str)
        End If
        If GetSettingValue(CurrentIndexPos, "EX_AD7:", Str) Then
            IC_Array(i).ExtScan_AD7 = Val(Str)
        End If
        
        If GetSettingValue(CurrentIndexPos, "EX_CAL_SCAN:", Str) Then
            IC_Array(i).bExtCalScan = Val(Str)
        End If
        If GetSettingValue(CurrentIndexPos, "EX_MUX_INVERT:", Str) Then
            IC_Array(i).bMuxInverted = Val(Str)
        End If
        
        If GetSettingValue(CurrentIndexPos, "TRIG_INPUT:", Str) Then
            IC_Array(i).bTrigInput = Val(Str)
        End If
        
        If GetSettingValue(CurrentIndexPos, "TRIG_EDGE:", Str) Then
            IC_Array(i).bTrigEdge = Val(Str)
        End If
        
        If GetSettingValue(CurrentIndexPos, "TRIG_SCAN:", Str) Then
            If Val(Str) = 1 Then
                IC_Array(i).bTrigOn = 1
            Else
                IC_Array(i).bTrigOn = 0
            End If
        End If
        
        For j = 0 To 15
            ' Load settings of thermocouples connected to AD0
            search = "AD0_THERM_" & j & "_K:"
            If GetSettingValue(CurrentIndexPos, search, Str) Then IC_Array(i).fAD0_K(j) = Val(Str)
            search = "AD0_THERM_" & j & "_G:"
            If GetSettingValue(CurrentIndexPos, search, Str) Then IC_Array(i).fAD0_G(j) = Val(Str)
            search = "AD0_THERM_" & j & "_TYPE:"
            If GetSettingValue(CurrentIndexPos, search, Str) Then IC_Array(i).fAD0_Type(j) = Trim$(Str)
            
            ' Load settings of thermocouples connected to AD1
            search = "AD1_THERM_" & j & "_K:"
            If GetSettingValue(CurrentIndexPos, search, Str) Then IC_Array(i).fAD1_K(j) = Val(Str)
            search = "AD1_THERM_" & j & "_G:"
            If GetSettingValue(CurrentIndexPos, search, Str) Then IC_Array(i).fAD1_G(j) = Val(Str)
            search = "AD1_THERM_" & j & "_TYPE:"
            If GetSettingValue(CurrentIndexPos, search, Str) Then IC_Array(i).fAD1_Type(j) = Trim$(Str)
        Next
        If GetSettingValue(CurrentIndexPos, "FAREN:", Str) Then
            IC_Array(i).bFaren = Val(Str)
        End If
        
        'graph chan settings
        For j = 0 To 15
        
            search = "AD0_CHAN_" & j & "_CLR:"
            If GetSettingValue(CurrentIndexPos, search, Str) Then IC_Array(i).PlotAD0ChanClr(j) = Val(Str)
            search = "AD0_CHAN_" & j & "_SHOW:"
            If GetSettingValue(CurrentIndexPos, search, Str) Then
                If CInt(Str) = 1 Then
                    IC_Array(i).PlotAD0ChanShow(j) = True
                Else
                    IC_Array(i).PlotAD0ChanShow(j) = False
                End If
            End If
            
            search = "AD1_CHAN_" & j & "_CLR:"
            If GetSettingValue(CurrentIndexPos, search, Str) Then IC_Array(i).PlotAD1ChanClr(j) = Val(Str)
            search = "AD1_CHAN_" & j & "_SHOW:"
            If GetSettingValue(CurrentIndexPos, search, Str) Then
                If CInt(Str) = 1 Then
                    IC_Array(i).PlotAD1ChanShow(j) = True
                Else
                    IC_Array(i).PlotAD1ChanShow(j) = False
                End If
            End If
        Next j
        
        search = "AD6_CHAN_CLR:"
        If GetSettingValue(CurrentIndexPos, search, Str) Then IC_Array(i).PlotAD6ChanClr = Val(Str)
        search = "AD6_CHAN_SHOW:"
        If GetSettingValue(CurrentIndexPos, search, Str) Then
            If GetSettingValue(CurrentIndexPos, search, Str) Then
                If CInt(Str) = 1 Then
                    IC_Array(i).PlotAD6ChanShow = True
                Else
                    IC_Array(i).PlotAD6ChanShow = False
                End If
            End If
        End If
            
        search = "AD7_CHAN_CLR:"
        If GetSettingValue(CurrentIndexPos, search, Str) Then IC_Array(i).PlotAD7ChanClr = Val(Str)
        search = "AD7_CHAN_SHOW:"
        If GetSettingValue(CurrentIndexPos, search, Str) Then
            If GetSettingValue(CurrentIndexPos, search, Str) Then
                If CInt(Str) = 1 Then
                    IC_Array(i).PlotAD7ChanShow = True
                Else
                    IC_Array(i).PlotAD7ChanShow = False
                End If
            End If
        End If
        
    Next
    If GetSettingValue(CurrentIndexPos, "NETWORK_EVENT_THREAD_PRIORITY :", Str) Then
        If Int(Str) >= 0 And Int(Str) <= 5 Then
            bNetworkEventThreadPriority = Int(Str)
        Else
            bNetworkEventThreadPriority = 5
        End If
    Else
        bNetworkEventThreadPriority = 5
    End If
    
    If GetSettingValue(CurrentIndexPos, "NETWORK_POLL_THREAD_PRIORITY :", Str) Then
        If Int(Str) >= 0 And Int(Str) <= 5 Then
            bNetworkPollThreadPriority = Int(Str)
        Else
            bNetworkPollThreadPriority = 5
        End If
    Else
        bNetworkPollThreadPriority = 0
    End If
    
    If GetSettingValue(CurrentIndexPos, "GRAPH_BKG_COLOR:", Str) Then
        fGraph.BkgGrphColor = CLng(Str)
    Else
        fGraph.BkgGrphColor = RGB(255, 0, 0)
    End If
    Call LoadExtraSetting
    Close #1
    Exit Sub
loadsettingerr:
    Close #1
End Sub

Sub SaveSetting()
    Dim RetMsgBox, i, j As Integer
    Dim contentstr
    'save the current setting to CfgFileName for next time using
    On Error GoTo ReadOnly
    Open CfgFileName For Output As #1
    For i = 0 To NumOf401s - 1
        'contentstr = "IP Address : " & fMainForm.IpAddrEdit
        contentstr = "IP Address : " & IC_Array(i).DPC_IPAddr
        Print #1, contentstr
        'contentstr = "Subnet mask: " & subnetmask
        contentstr = "Subnet mask: " & IC_Array(i).DPC_Subnet
        Print #1, contentstr
        'contentstr = "GateWay IP : " & gatewayip
        contentstr = "GateWay IP : " & IC_Array(i).DPC_Gateway
        Print #1, contentstr
        'contentstr = "DHCP tmout : " & Trim$(Str(dhcptmout))
        contentstr = "DHCP tmout : " & IC_Array(i).DPC_DhcpTimeout
        Print #1, contentstr
        'contentstr = "Scan Avg   : " & fMainForm.ComboAvg
        contentstr = "Scan Avg   : " & IC_Array(i).DPC_ScanAvg
        Print #1, contentstr
        'contentstr = "Digital out: " & fMainForm.EditDigout
        contentstr = "Digital out: " & IC_Array(i).DPC_DigOut
        Print #1, contentstr
        
        'If fMainForm.BtnScreenTypeSelect.Caption = "Change to Scan &Mode" Then
        If (IC_Array(i).DPC_ScanMode = MULT_CHAN_SCAN) Or (IC_Array(i).DPC_ScanMode = MULT_CHAN_CAL_SCAN) Then
            contentstr = "Multi  chan: " & 1
        Else
            contentstr = "Multi  chan: " & 0
        End If
        Print #1, contentstr
        
        If (IC_Array(i).DPC_ScanMode = EXTENDED_SCAN) Then
            contentstr = "Ext Scan: 1"
        Else
            contentstr = "Ext Scan: 0"
        End If
        Print #1, contentstr
        
        If (IC_Array(i).DPC_ScanMode = MULT_CHAN_CAL_SCAN) Or (IC_Array(i).DPC_ScanMode = EXTENDED_SCAN) Then
            If (IC_Array(i).DPC_ScanMode = EXTENDED_SCAN) Then
                contentstr = "Cal.   scan: " & IC_Array(i).bExtCalScan
            Else
                contentstr = "Cal.   scan: " & 1
            End If
        Else
            contentstr = "Cal.   scan: " & 0
        End If
        Print #1, contentstr
        
        contentstr = "Number chan: " & IC_Array(i).DPC_NumOfChan
        Print #1, contentstr
        contentstr = "AC/DC  mode: 0"
        Print #1, contentstr
        contentstr = "Disp   chan: " & IC_Array(i).DPC_DispChan
        Print #1, contentstr
        contentstr = "Volts/Div  : " & IC_Array(i).DPC_ZoomIndex
        Print #1, contentstr
        contentstr = "Scan Rate  : " & Format$(IC_Array(i).DPC_ScanRate, "##0000.00")
        Print #1, contentstr
        contentstr = "GraphTimeBase  :" & IC_Array(i).DPC_GraphTimeBase
        Print #1, contentstr
        'Save Extended Scan settings
        contentstr = "EX_AD0_START: " & IC_Array(i).ExtScan_AD0_Start
        Print #1, contentstr
        contentstr = "EX_AD0_END: " & IC_Array(i).ExtScan_AD0_End
        Print #1, contentstr
        contentstr = "EX_AD1_START: " & IC_Array(i).ExtScan_AD1_Start
        Print #1, contentstr
        contentstr = "EX_AD1_END: " & IC_Array(i).ExtScan_AD1_End
        Print #1, contentstr
        contentstr = "EX_AD6: " & IC_Array(i).ExtScan_AD6
        Print #1, contentstr
        contentstr = "EX_AD7: " & IC_Array(i).ExtScan_AD7
        Print #1, contentstr
        contentstr = "EX_CAL_SCAN: " & IC_Array(i).bExtCalScan
        Print #1, contentstr
        contentstr = "EX_MUX_INVERT: " & IC_Array(i).bMuxInverted
        Print #1, contentstr
        contentstr = "TRIG_INPUT: " & IC_Array(i).bTrigInput
        Print #1, contentstr
        contentstr = "TRIG_EDGE: " & IC_Array(i).bTrigEdge
        Print #1, contentstr
        If IC_Array(i).bTrigOn = 1 Then
            contentstr = "TRIG_SCAN: 1"
        Else
            contentstr = "TRIG_SCAN: 0"
        End If
        Print #1, contentstr
        ' write thermo couple settings to config file
        For j = 0 To 15
            contentstr = "AD0_THERM_" & j & "_K:" & IC_Array(i).fAD0_K(j)
            Print #1, contentstr
            contentstr = "AD0_THERM_" & j & "_G:" & IC_Array(i).fAD0_G(j)
            Print #1, contentstr
            contentstr = "AD0_THERM_" & j & "_TYPE:" & IC_Array(i).fAD0_Type(j)
            Print #1, contentstr
        Next j
        For j = 0 To 15
            contentstr = "AD1_THERM_" & j & "_K:" & IC_Array(i).fAD1_K(j)
            Print #1, contentstr
            contentstr = "AD1_THERM_" & j & "_G:" & IC_Array(i).fAD1_G(j)
            Print #1, contentstr
            contentstr = "AD1_THERM_" & j & "_TYPE:" & IC_Array(i).fAD1_Type(j)
            Print #1, contentstr
        Next j
        contentstr = "FAREN:" & IC_Array(i).bFaren
        Print #1, contentstr
        For j = 0 To 15
            contentstr = "AD0_CHAN_" & j & "_CLR:" & IC_Array(i).PlotAD0ChanClr(j)
            Print #1, contentstr
            If IC_Array(i).PlotAD0ChanShow(j) Then
                contentstr = "AD0_CHAN_" & j & "_SHOW: 1"
            Else
                contentstr = "AD0_CHAN_" & j & "_SHOW: 0"
            End If
            Print #1, contentstr
        Next j

        For j = 0 To 15
            contentstr = "AD1_CHAN_" & j & "_CLR:" & IC_Array(i).PlotAD1ChanClr(j)
            Print #1, contentstr
            If IC_Array(i).PlotAD1ChanShow(j) Then
                contentstr = "AD1_CHAN_" & j & "_SHOW: 1"
            Else
                contentstr = "AD1_CHAN_" & j & "_SHOW: 0"
            End If
            Print #1, contentstr
        Next j
        
        contentstr = "AD6_CHAN_CLR:" & IC_Array(i).PlotAD6ChanClr
        Print #1, contentstr
        If IC_Array(i).PlotAD6ChanShow Then
            contentstr = "AD6_CHAN_SHOW: 1"
        Else
            contentstr = "AD6_CHAN_SHOW: 0"
        End If
        Print #1, contentstr
        
        contentstr = "AD7_CHAN_CLR:" & IC_Array(i).PlotAD7ChanClr
        Print #1, contentstr
        If IC_Array(i).PlotAD7ChanShow Then
            contentstr = "AD7_CHAN_SHOW: 1"
        Else
            contentstr = "AD7_CHAN_SHOW: 0"
        End If
        Print #1, contentstr
        
        Print #1, "        "
    Next
    contentstr = "NETWORK_EVENT_THREAD_PRIORITY :" & bNetworkEventThreadPriority
    Print #1, contentstr
    contentstr = "NETWORK_POLL_THREAD_PRIORITY :" & bNetworkPollThreadPriority
    Print #1, contentstr
    contentstr = "GRAPH_BKG_COLOR:" & fGraph.BkgGrphColor
    Print #1, contentstr
   
    For i = 0 To ExtraSettingLen - 1
        Print #1, ExtraSetting(i)
    Next
    Close #1
    Exit Sub
ReadOnly:
     'RetMsgBox = MsgBox("Cfg file read only", vbExclamation, "Error")
     End Sub

' Check Callback.cfg for the passed "keyword". If found return TRUE
' or else return FALSE


Public Function CheckForKeyWord(ByVal Filename As String, ByVal keyword As String) As Boolean
Dim sTemp As String
Dim i, j As Integer
CheckForKeyWord = False
On Error GoTo FileNotPresent    'if there is no such file
Open Filename For Input As #1
Do While Not EOF(1)
    Input #1, sTemp
    sTemp = Trim$(sTemp)
    sTemp = UCase(sTemp)
    keyword = UCase(keyword)
    i = InStr(1, sTemp, keyword, vbTextCompare)
    If i <> 0 Then
        j = InStr(1, sTemp, "//", vbTextCompare)
        If j = 0 Or j > i Then CheckForKeyWord = True
    End If
Loop
Close #1
FileNotPresent:
End Function

Public Function CheckFilePresent(ByVal Filename As String) As Boolean
On Error GoTo NoFile
Open Filename For Input As #1
Close #1
CheckFilePresent = True
Exit Function
NoFile:
CheckFilePresent = False
End Function

' Convert a DLL function's return code into a string and return
Public Function CodeToStr(DLLRetCode As RETURN_CODE) As String
CodeToStr = ""
Select Case DLLRetCode

    Case 0
         CodeToStr = "COMMAND_OK"
    
    Case 1
         CodeToStr = "CALIBRATION_ERROR"
         
    Case 2
         CodeToStr = "ECHO_ERROR"
         
    Case 3
          CodeToStr = "INIT_FAILURE"
    
    Case 4
         CodeToStr = "INVALID_ARGUMENT"
        
    Case 5
         CodeToStr = "RESET_FAILURE"
         
    Case 6
         CodeToStr = "TIME_OUT"
    
    Case 7
         CodeToStr = "CHKSUM_ERROR"
    
    Case 8
         CodeToStr = "SET_RATE_FAILURE"
         
    Case 9
         CodeToStr = "CHECK_POWER"
         
    Case 10
         CodeToStr = "INVALID_COMMAND"
         
    Case 11
         CodeToStr = "NO_ECHO_COMMAND"
         
    Case 12
         CodeToStr = "SOCKET_SEND_ERROR"
         
    Case 13
         CodeToStr = "PENDING"
         
    Case 14
         CodeToStr = "OUT_OF_SYNC"
         
    Case 15
         CodeToStr = "FLUSH_TIME_OUT"
         
    Case 16
         CodeToStr = "FEWER_BYTES_RECVD"
         
    Case 17
        CodeToStr = SOCKET_EVENT_FAIL
        
    Case INVALID_STATE
        CodeToStr = "INVALID_STATE"
        
    Case NOT_CONNECTED
        CodeToStr = "NOT_CONNECTED"
        
    Case INIT_TIMER_FAILED
        CodeToStr = "INIT_TIMER_FAILED"
        
    Case I0_ERROR
        CodeToStr = "IO_ERROR"
End Select
 
End Function
'CurrentIndexPos - position of the current index in the file stream. For the first index pass 0
'IP_Address - If the function is successfull in finding the next index then this contains the IP address
'This function searches for IP Address : tag in the cfg starting from CurrentIndexPos. Config settings
'of an index are found between the IP Address  : tag for the index and IP Address  : tag for the next
'index
'Return Value -  -1 if unsuccessfull in finding the next index, else position of the next index in the cfg file
' Make sure file #1 is already open before calling this func
Private Function GetNextIndexPos(ByVal CurrentIndexPos As Integer, ByRef IP_Address As String) As Integer
Dim Line
Dim i As Integer
GetNextIndexPos = -1
On Error GoTo Error1
Seek #1, CurrentIndexPos
Do While Not EOF(1)
    Input #1, Line
    i = InStr(1, UCase(Line), "IP ADDRESS :", vbTextCompare)
    If i <> 0 Then
     'Found the next IP Address : tag
     IP_Address = Right(Line, Len(Line) - ((i - 1) + Len("IP ADDRESS :")))
     IP_Address = Trim(IP_Address)
     GetNextIndexPos = Seek(1)
     Exit Function
    End If
Loop
Error1: Exit Function
End Function

'Searches for the tag starting from the current index till the start of the next next index.
'If the tag is found then function returns true and value will contain the value associated
'with the tag
'CurrentIndexPos - position of the current index in the file stream. For the first index pass 0
'SearchTag - Tag to be searched
'Value - will contain value associated with the setting
Private Function GetSettingValue(ByVal CurrentIndexPos As Integer, ByVal SearchTag As String, ByRef Value As String) As Boolean
Dim Line
Dim i As Integer
GetSettingValue = False
On Error GoTo Error2
Seek #1, CurrentIndexPos
Do While Not EOF(1)
    Input #1, Line
    i = InStr(1, UCase(Line), "IP ADDRESS :", vbTextCompare)
    If i <> 0 Then Exit Do   'crossed over to next index
    i = InStr(1, UCase(Line), UCase(SearchTag), vbTextCompare)
    If i <> 0 Then
    'found the tag we are searching for
        Value = Right(Line, Len(Line) - ((i - 1) + Len(SearchTag)))
        Value = Trim(Value)
        GetSettingValue = True
        Exit Function
    End If
Loop
Error2: Exit Function
End Function

'User may have inserted some extra lines, as comments or as debug settings
'for the dll. These extra lines must be saved at startup so that they are not lost
'when the cfg file is overwritten by the current settings of the indices at shutdown.
' After writing the settings of all the indices, the extra lines are written.
Private Sub LoadExtraSetting()
 Dim Line
 Dim i As Integer
 On Error GoTo Error3
 Seek #1, 1
 Do While Not EOF(1)
   Input #1, Line
   Line = Trim(Line)
   If Line <> "" Then
    i = InStr(1, UCase(Line), UCase("IP Address :"), vbTextCompare) + InStr(1, UCase(Line), UCase("Subnet mask:"), vbTextCompare) + InStr(1, UCase(Line), UCase("GateWay IP :"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("DHCP tmout :"), vbTextCompare) + InStr(1, UCase(Line), UCase("Scan Avg   :"), vbTextCompare) + InStr(1, UCase(Line), UCase("Scan Avg   :"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("Digital out:"), vbTextCompare) + InStr(1, UCase(Line), UCase("Polled mode:"), vbTextCompare) + InStr(1, UCase(Line), UCase("Multi  chan:"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("Cal.   scan:"), vbTextCompare) + InStr(1, UCase(Line), UCase("Number chan:"), vbTextCompare) + InStr(1, UCase(Line), UCase("AC/DC  mode:"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("Disp   chan:"), vbTextCompare) + InStr(1, UCase(Line), UCase("Volts/Div  :"), vbTextCompare) + InStr(1, UCase(Line), UCase("Scan Rate  :"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("GraphTimeBase  :"), vbTextCompare) + InStr(1, UCase(Line), UCase("NETWORK_EVENT_THREAD_PRIORITY :"), vbTextCompare) + InStr(1, UCase(Line), UCase("NETWORK_POLL_THREAD_PRIORITY :"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("EX_AD0_START:"), vbTextCompare) + InStr(1, UCase(Line), UCase("EX_AD0_END:"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("EX_AD1_START:"), vbTextCompare) + InStr(1, UCase(Line), UCase("EX_AD1_END:"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("EX_AD6:"), vbTextCompare) + InStr(1, UCase(Line), UCase("EX_AD7:"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("EX_CAL_SCAN:"), vbTextCompare) + InStr(1, UCase(Line), UCase("EX_MUX_INVERT:"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("TRIG_INPUT:"), vbTextCompare) + InStr(1, UCase(Line), UCase("TRIG_EDGE:"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("TRIG_SCAN:"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("AD0_THERM_"), vbTextCompare) + InStr(1, UCase(Line), UCase("AD1_THERM_"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("FAREN:"), vbTextCompare) + InStr(1, UCase(Line), UCase("GRAPH_BKG_COLOR:"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("AD0_CHAN"), vbTextCompare) + InStr(1, UCase(Line), UCase("AD1_CHAN"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("AD6_CHAN"), vbTextCompare) + InStr(1, UCase(Line), UCase("AD7_CHAN"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("ORG_MODE_DISP"), vbTextCompare)
    i = i + InStr(1, UCase(Line), UCase("Ext Scan:"), vbTextCompare)
    If i = 0 Then
    ' This line does not have a index setting, so it must be a extra setting.
        If (ExtraSettingLen = MAX_EXTRA_SETTING) Then GoTo Error3
            ExtraSetting(ExtraSettingLen) = Line
            ExtraSettingLen = ExtraSettingLen + 1
        End If
    End If
 Loop
Error3:  Exit Sub
End Sub
' Formats volts for display/logging with the correct number of decimal places (based on the A/D range)
' so that atleast 22-bits can be seen
Public Function FormatVolts(ByVal fVolt As Double, ByVal Index As Integer) As String
Dim RetStr As String
Select Case Scan_obj(Index).bADRange
Case 2, 7 '1V, 2V  range - 7 dec places
    RetStr = Format$(fVolt, " 0.0000000;-0.0000000")
Case 3, 4, 5 '0.1,0.2,0.045V range - 8 dec places
    RetStr = Format$(fVolt, " 0.00000000;-0.00000000")
Case Else ' all other ranges - 6 dec places
    RetStr = Format$(fVolt, " 0.000000;-0.000000")
End Select
FormatVolts = RetStr
End Function



Public Function GetErrorLogsStr() As String
Dim bArray() As Byte
Dim lErrStrLen As Long
Dim bPercMemUsed As Byte
Dim itemStr As String
itemStr = ""
ReDim bArray(1)
lErrStrLen = 0
itemStr = ""
bPercMemUsed = 0
DLLCallRet = Pub_GetErrorLogsStr(Scan_obj(Selected_Index), bArray(0), lErrStrLen, bPercMemUsed)
If lErrStrLen <> 0 Then
    If DLLCallRet = COMMAND_SUCCESS Then
        ReDim bArray(lErrStrLen + 1)  'Allocate the required space
        DLLCallRet = Pub_GetErrorLogsStr(Scan_obj(Selected_Index), bArray(0), lErrStrLen + 1, bPercMemUsed)
        If DLLCallRet = COMMAND_SUCCESS Then
            itemStr = StrConv(bArray, vbUnicode)
        End If
    End If
End If
GetErrorLogsStr = itemStr
If bPercMemUsed <> 0 Then
    GetErrorLogsStr = GetErrorLogsStr & Chr(10) & "Error log memory used " & bPercMemUsed & "%"
End If
End Function

' Get self test string and check for corrupt error log memory
Function IsCorruptErrorLog(ByRef ScanObj As SSCAN_OBJ) As Boolean
Dim itemStr As String
Dim nPos, i As Integer
Dim DLLCallRet As RETURN_CODE
Dim strSelfTst(2048) As Byte
IsCorruptErrorLog = False
If Pub_IsFirmwareVersionGreaterThanEqualTo(ScanObj, 5, 2, 2007) <> 0 Then
    'Firmware version supports the newer get selt test 2
    DLLCallRet = Pub_GetSelfTestRst2(ScanObj, strSelfTst(0))
    If DLLCallRet = COMMAND_SUCCESS Then
        i = 0
        itemStr = ""
        Do
            If strSelfTst(i) <> 10 Then 'parse the returning string
                itemStr = itemStr & Chr$(strSelfTst(i))
            Else
                nPos = InStr(itemStr, "Corrupted Log Memory")
                If nPos > 0 Then IsCorruptErrorLog = True
                itemStr = ""
            End If
            i = i + 1
        Loop While (strSelfTst(i) <> 0) 'loop to the end of the string
    End If
End If
'If IsCorruptErrorLog Then Call MsgBox("Corrupt Log Memory")
End Function
